﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace PositiveNumberTexBox
{
    public partial class PositiveNumberTextBox : TextBox
    {
        public delegate void NegativeNumberHandler();
        public event NegativeNumberHandler OnNegativeNumber;
        private ErrorProvider virhe = new ErrorProvider();

        public PositiveNumberTextBox()
        {
            InitializeComponent();
        }
        protected override void OnValidating(CancelEventArgs e)
        {
            try
            {
                if (double.Parse(this.Text) < 0)
                {
                    if (OnNegativeNumber != null) OnNegativeNumber();
                    e.Cancel = true;
                    virhe.SetError(this, "Syötit negatiivisen luvun! Vain positiiviset luvut kelpaavat!");
                }
            }
            catch (Exception)
            {
                e.Cancel = true;
                virhe.SetError(this, "Et syöttänyt numeroa! Vain positiiviset luvut kelpaavat!");
            }

            base.OnValidating(e);
        }
        protected override void OnValidated(EventArgs e)
        {
            virhe.SetError(this, null);
            base.OnValidated(e);
        }


    }
}
